
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Display the results of the ForWaRD algorithm
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


if OrgSigAvailable
  figure(3)
  subplot(7,1,1)
  plot(x)
  junk = axis;
  axis([1 N junk(3) junk(4)]); rmaxis
  title(strcat('Original signal'))

  
  subplot(7,1,2)
  plot(y)
  junk = axis;
  axis([1 N junk(3) junk(4)]); rmaxis
  title(strcat('Blurred and Noisy observation'))

  subplot(7,1,3)
  plot(xwiener)
  junk = axis;
  axis([1 N junk(3) junk(4)]); rmaxis
  SNRWDWF = 10*log10(norm(x(:))^2 /norm(xwiener(:) - x(:))^2 );
  SNRWDWF = round(100*SNRWDWF)/100;
  title(strcat('Wiener, SNR = ', num2str(SNRWDWF),'dB'))

  subplot(7,1,4)
  plot(xrefwvd)
  junk = axis;
  axis([1 N junk(3) junk(4)]); rmaxis
  SNRWDWF = 10*log10(norm(x(:))^2 /norm(xrefwvd(:) - x(:))^2 );
  SNRWDWF = round(100*SNRWDWF)/100;
  title(strcat('WVD (with hardthresh), SNR = ', num2str(SNRWDWF),'dB'))
  disp([' '])
  disp(['WVD (with hardthresh): Performs hardthresholding for the wavelet domain processing step'])

  
  subplot(7,1,5)
  plot(xwvd)
  junk = axis;
  axis([1 N junk(3) junk(4)]); rmaxis
  SNRWDWF = 10*log10(norm(x(:))^2 /norm(xwvd(:) - x(:))^2 );
  SNRWDWF = round(100*SNRWDWF)/100;
  title(strcat('WVD (with WDWF), SNR = ', num2str(SNRWDWF),'dB'))
  disp([' '])
  disp(['WVD (with WDWF): Performs wavelet domain wiener filtering (WDWF) during the wavelet domain processing step'])

  subplot(7,1,6)
  plot(xref)
  junk = axis;
  axis([1 N junk(3) junk(4)]); rmaxis
  SNRWDWF = 10*log10(norm(x(:))^2 /norm(xref(:) - x(:))^2 );
  SNRWDWF = round(100*SNRWDWF)/100;
  title(strcat('ForWaRD (with hardthresh), SNR = ', num2str(SNRWDWF),'dB'))
  disp([' '])
  disp(['ForWaRD (with hardthres): Performs hardthresholding for the wavelet domain processing step'])

  subplot(7,1,7)
  plot(xward)
  junk = axis;
  axis([1 N junk(3) junk(4)]); rmaxis
  SNRWDWF = 10*log10(norm(x(:))^2 /norm(xward(:) - x(:))^2 );
  SNRWDWF = round(100*SNRWDWF)/100;
  title(strcat('ForWaRD (with WDWF), SNR = ', num2str(SNRWDWF),'dB'))
  disp([' '])
  disp(['ForWaRD (with WDWF): Performs wavelet domain wiener filtering (WDWF) during the wavelet domain processing step'])

else
  
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  figure(3)
  subplot(6,1,1)
  plot(y)
  junk = axis;
  axis([1 N junk(3) junk(4)]); rmaxis
  title(strcat('Blurred and Noisy observation'))

  subplot(6,1,2)
  plot(xwiener)
  junk = axis;
  axis([1 N junk(3) junk(4)]); rmaxis
  title(strcat('Wiener'))

  subplot(6,1,3)
  plot(xrefwvd)
  junk = axis;
  axis([1 N junk(3) junk(4)]); rmaxis
  title(strcat('WVD (with hardthresh)'))
  disp([' '])
  disp(['WVD (with hardthresh): Performs hardthresholding for the wavelet domain processing step'])

  
  subplot(6,1,4)
  plot(xwvd)
  junk = axis;
  axis([1 N junk(3) junk(4)]); rmaxis
  title(strcat('WVD (with WDWF)'))
  disp([' '])
  disp(['WVD (with WDWF): Performs wavelet domain wiener filtering (WDWF) during the wavelet domain processing step'])

  subplot(6,1,5)
  plot(xref)
  junk = axis;
  axis([1 N junk(3) junk(4)]); rmaxis
  title(strcat('ForWaRD (with hardthresh)'))
  disp([' '])
  disp(['ForWaRD (with hardthresh): Performs hardthresholding for the wavelet domain processing step'])

  subplot(6,1,6)
  plot(xward)
  junk = axis;
  axis([1 N junk(3) junk(4)]); rmaxis
  title(strcat('ForWaRD (with WDWF)'))
  disp([' '])
  disp(['ForWaRD (with WDWF): Performs wavelet domain wiener filtering (WDWF) during the wavelet domain processing step'])

 end

