%Software author: 	Ramesh Neelamani
%Modification Date: 	January 31, 2004
%Comments: 		neelsh@rice.edu

% This part sets estimates the noise variance and the regularization
% parameter.

sqrdtempnorm = ((norm(y-mean(y))^2 )/(norm(h,1))^2); % using
                                                     % minkowski's ineq
tempreg = sigma^2*N/(sqrdtempnorm);

if RegSearch == 'N'
    % Nothing to do
    % Old stuff: regparam = RegParam*sigma^2*N/(norm(y(:) -mean(y(:)))^2);
    % had problems with small H

    regparam = RegParam*sigma^2*N/sqrdtempnorm;
    disp(' ')
    disp(['Using a pre-set regularization parameter. For automatic estimation, set RegSearch = Y in ExptSetup.m file (recommended).'])
    disp(' ')
else  
  clear Actualmse Obsnorm 
  
  GenericRegInv = (conj(H)) ./ ((abs(H).^2 ) + tempreg );
  GenericObs = real(ifft(Y .* GenericRegInv));
  disp(strcat('Testing ',{' '},num2str(length(RegParam)),{' '},'reg parameters')); 
  for regcounter = 1:length(RegParam)
    regparam = RegParam(regcounter)*tempreg;  
    RunForWaRD1D
    % xward is the forward estimate
    %disp(strcat('Testing regularization parameter number', {' '}, num2str(regcounter),{' '},'of', {' '}, num2str(length(RegParam))))
    if  OrgSigAvailable
      Actualmse(regcounter) = norm(xward(:) - x(:)); % for comparison purposes
    end
    temp = real(ifft(fft(xward(:)) .* H(:) .* GenericRegInv(:)));
    Obsnorm(regcounter) = norm(temp(:) - GenericObs(:));
  end  
  if RegDebug == 1
    figure(100)
    hold on
    semilogx(RegParam,Obsnorm,'r')
    semilogx(RegParam,Actualmse,'k')
    title('Obsnorm = red, Actual = black')
  end
  
  clear GenericObs  GenericRegInv temp
  if OrgSigAvailable
    ActualmsedB = -20*log10(Actualmse/(norm(x(:))));
    [MaxMSE,ind] = max(ActualmsedB);
    MaxMSEReg = RegParam(ind);
  end
  [a,ObsInd] = min(Obsnorm);
  if ((ObsInd == 1)| (ObsInd == length(RegParam))) & (IterCount < 4)
    disp(RegParam.')
    if (ObsInd == 1)
      disp('Including smaller Reg Parameters in search')
      RegParam = RegParam/10;
      IterCount = IterCount +1;
      RegParamSetup1D;
    elseif (ObsInd == length(RegParam))
	disp('Including larger Reg Parameters in search')
	RegParam = RegParam*10;
	IterCount = IterCount +1;
	RegParamSetup1D;
    end
  else
    if OrgSigAvailable
      ActualmsedB = -20*log10(Actualmse/(norm(x(:))));
      [a,ind] = max(ActualmsedB);
      if MaxMSE < a
	MaxMSE = a;
	MaxMSEReg = RegParam(ind);
      end
      disp(strcat('Best possible performance is =',num2str(MaxMSE)));
      disp(strcat('Best Reg Parameter is =',num2str(MaxMSEReg)));
    end
    
    [a,ObsInd] = min(Obsnorm);
    disp(strcat('Chosen Reg Parameter is (not using orig signal) =',num2str(RegParam(ObsInd))));
    if OrgSigAvailable
      disp(strcat('Chosen performance from Observation norm is =',num2str(ActualmsedB(ObsInd))));    
    end    
    regparam = RegParam(ObsInd)*tempreg;
  end    
end








