% mrdwtcycle1D.m
%
% Same as mrdwt(), just returns the results in a nicer matrix (indexed
% correctly for these tree algorithms).
% Usuage : [yw, ys] = mrdwtcycle1D(x, h, L)
% yw - wavelet coefficients.  NxL. (yw(:,1) is coarsest scale)
% ys - scaling coefficients.  N.
%
% Written by : Neelsh

function [yw,ys] = mrdwtcycle1d(x, h, L)

  [ys,yh] = mrdwt(x, h, L);
  yh = yh(:);
  N = length(x);
  yw = zeros(N,L);
  for lev = 0:1:L-1
    yw(:,L-lev) = yh(lev*N +1:(lev+1)*N);
  end
  

